#!/usr/bin/perl

use strict;
use warnings;

my $mdb = shift;

die 'what file?' unless ( -e $mdb );

$SIG{'PIPE'} = sub { die 'SIGPIPE' };
open(SQLITE, "| sqlite3 $mdb.sqlite") || die 'fork failed';

my $re_drop = qr/DROP TABLE/o;
my $re_blob = qr/(?:varbinary \(\d+\))(,?) *$/o;
my $re_int  = qr/(?:bit|int)(,?) *$/o;
my $re_text = qr/(?:\w*datetime|(?:text|varchar) \(\d+\))(,?) *$/o;

foreach(qx(mdb-schema $mdb sybase)) {
	s/$re_drop/DROP TABLE IF EXISTS/o;
	s/$re_blob/BLOB$1/o;
	s/$re_int/INTEGER$1/o;
	s/$re_text/TEXT$1/o;
	print SQLITE;
}

foreach(qx(mdb-tables -1 $mdb)) {
	foreach my $line (qx(mdb-export -R ';\\n' -I $mdb $_)) {
		print SQLITE $line || die 'failed print';
	}
}

close SQLITE || die 'failed close: ' . $!;

exit 0;
